<?php

namespace App\Core\Service;

use App\Core\Repository\ChannelManagerBooking\ChannelManagerBookingRepository;

use App;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Config;
use Exception;
use App\Exceptions\ApiErrorException;
use Illuminate\Support\Carbon;

class ChannelManagerBookingService
{

    private $channelManagerBookingRepository;


    public function __construct(
        ChannelManagerBookingRepository $channelManagerBookingRepository
    )
    {
        $this->channelManagerBookingRepository = $channelManagerBookingRepository;
    }

    public function select($param = [], $column = ['*'])
    {

        $response = ['status' => -1, 'message' => '', 'data' => null];

        try {

            $data = $this->channelManagerBookingRepository->findByCriteria($param, $column);

            $response = [
                'status' => true,
                'data' => $data,
            ];

        } catch (ApiErrorException $e) {
            $response['message'] = $e->getMessage();
        } catch (Exception $e) {
            $message = $e->getFile() . " " . $e->getLine() . " " . $e->getMessage();
            Log::error($message);
            $response['message'] = $e->getMessage();
        }

        return output($response);
    }

    public function create($params = [])
    {
        $response = ['status' => -1, 'message' => '', 'data' => null];
        try {

            $insertData = [
                'property_id' => fillOnUndefined($params, 'property_id'),
                'booking_id' => fillOnUndefined($params, 'booking_id'),
                'channel_manager_id' => fillOnUndefined($params, 'channel_manager_id'),
                'type' => fillOnUndefined($params, 'type', 'Booking'),
                'status' => fillOnUndefined($params, 'status', 1)
            ];

            $createResult = $this->channelManagerBookingRepository->create($insertData);

            if ($createResult['status'] != 'success') {
                throw new Exception('api-unknown_error');
            }

            $response = [
                'status' => true,
                'data' => $createResult["data"],
            ];

        } catch (ApiErrorException $e) {
            $response['message'] = implode(', ', $e->getMessageArr());
        } catch (Exception $e) {
            $message = $e->getFile() . " " . $e->getLine() . " " . $e->getMessage();
            Log::error($message);
            $response['message'] = $e->getMessage();
        }

        return output($response);
    }

    public function update($id, $param = [])
    {


        $response = ['status' => -1, 'message' => '', 'data' => null];
        try {


            $updateResult = $this->channelManagerBookingRepository->update($id, $param);
            if ($updateResult['status'] != 'success') {
                throw new Exception('api-unknown_error');
            }
            $updateData = $updateResult["data"];
            $response = [
                'status' => true,
                'data' => $updateData,
            ];

        } catch (ApiErrorException $e) {
            $response['message'] = implode(', ', $e->getMessageArr());
        } catch (Exception $e) {
            $message = $e->getFile() . " " . $e->getLine() . " " . $e->getMessage();
            Log::error($message);
            $response['message'] = $e->getMessage();
        }

        return output($response);
    }

    public function delete($ids = []){

        $response = ['status' => -1, 'message' => '', 'data' => null];
        try {


            $deleteResult = $this->channelManagerBookingRepository->destroy($ids);

            if ($deleteResult['status'] != 'success') {
                throw new ApiErrorException('api-unknown_error');
            }

            $response = [
                'status' => true,
                'data' => $deleteResult['data'] // affected row count
            ];

        } catch (ApiErrorException $e) {
            $response['message'] = implode(', ', $e->getMessageArr());
        } catch (Exception $e) {
            $message = $e->getFile() . " " . $e->getLine() . " " . $e->getMessage();
            Log::error($message);
            $response['message'] = $e->getMessage();
        }

        return output($response);

    }

}
